// GVNGPlugin.cpp : implementation file
//

#include "stdafx.h"
#include "GVNGPlugin.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// GVNGPlugin

GVNGPlugin::GVNGPlugin()
{
	m_pDataManager = NULL;
	m_hMainFrame = NULL;
	m_pEventMask = NULL;
	pMainFrame = NULL;
}


BEGIN_MESSAGE_MAP(GVNGPlugin, CWinApp)
	//{{AFX_MSG_MAP(GVNGPlugin)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// GVNGPlugin 

void GVNGPlugin::DataAccess(CString game, LONG turn, CString func, CStringList& param, CMapStringToString& map)
{
	if (!m_pDataManager) return;
	CString buf;
	map.RemoveAll();
	map.SetAt(_T("GameName"),game);
	buf.Format("%lu",turn);
	map.SetAt(_T("Turn"),buf);
	map.SetAt(_T("Function"),func);
	LONG cnt = param.GetCount(),i=0;
	buf.Format("%lu",cnt);
	map.SetAt(_T("Parameters.Count"),buf);
	for(POSITION pos = param.GetHeadPosition();pos;param.GetNext(pos))
	{
		buf.Format("Parameter.%lu",++i);
		map.SetAt(buf,param.GetAt(pos));
	}
	(*(void(*)(CMapStringToString&))m_pDataManager)(map);
}

void GVNGPlugin::RegRead(CString name, CString& var)
{
	CMapStringToString map;
	PUT_DATA("Function","ReadRegistry");
	PUT_DATA("Name",name);
	var.Empty();
	(*(void(*)(CMapStringToString&))m_pDataManager)(map);
	CString err;
	err=map["LastError"];
	if (!err.IsEmpty()) {TRACE("%s\r\n",(LPCTSTR)err);} else GET_DATA(name,var);
}

void GVNGPlugin::RegWrite(CString name, CString var)
{
	CMapStringToString map;
	PUT_DATA("Function","WriteRegistry");
	PUT_DATA("Name",name);
	PUT_DATA(name,var);
	(*(void(*)(CMapStringToString&))m_pDataManager)(map);
	CString err;
	GET_DATA("LastError",err);
	if (!err.IsEmpty()) {TRACE("%s\r\n",(LPCTSTR)err);}
}

void GVNGPlugin::OnInitialize(CMapStringToString& map)
{
	CString buf;
	if (map.Lookup(_T("MainFrame"),buf)) m_hMainFrame = (HWND)atol(buf);
	ASSERT(m_hMainFrame);
	if (map.Lookup(_T("DataManager"),buf)) m_pDataManager = (FARPROC)atol(buf);
	ASSERT(m_pDataManager);
	if (map.Lookup(_T("EventMask"),buf)) m_pEventMask = (DWORD*)atol(buf);
	ASSERT(m_pEventMask);
	if (map.Lookup(_T("MainFramePtr"),buf)) pMainFrame = (CFrameWnd*)atol(buf); //     GVNG v2.00-1  
	ASSERT(pMainFrame);
}


